﻿require("SignObserver.nut");
require("WhackATree.nut");

class WhackGS extends GSController 
{
	constructor()
	{
	}
	
	wat = {};
}

function WhackGS::Start()
{	
	local sign_observer = SignObserver();
	sign_observer.AddGeneralEventListener(this.OnSign.bindenv(this));
	
	while(true)
	{
		sign_observer.Check();
		
		foreach (company_id, wat in this.wat)
		{
			if (wat.Finished())
				delete this.wat[company_id];
			else
				wat.Step();
		}
		this.Sleep(3);
	}
}

function WhackGS::OnSign(event)
{
	GSLog.Info(event.event_type + ", " +event.sign_id + ", " +event.text);
	switch(event.event_type)
	{
		case SignObserverEvent.SOE_ADDED:
		case SignObserverEvent.SOE_CHANGED:
			if (event.text == "!play")
			{
				// already playing?
				if (event.company_id in this.wat) return;
				
				// Create game instance and start.
				local wat = WhackATree(event.company_id, event.tile_id, event.sign_id);
				wat.Start();
				
				// Also store it.
				this.wat[event.company_id] <- wat;
			}
		break;
		default:
	}
}